(()=>{"use strict";
/**
 * DragDropAnnotate
 * https://github.com/AntoninoBonanno/DragDropAnnotate
 * @author Bonanno Antonino
 * @version v1.2.0
 * @licence LGPL-3.0-or-later
 *
 * jQuery plugin to annotate images easily with drag and drop.
 * DragDropAnnotate is a lightweight image annotation tool that make it easy to add custom markers, comments, hotspots to images via drag and drop.
 * Supports rectangle, and image annotations. The drag and drop functionality based on jQuery UI draggable widget.
 */
{var T=jQuery;const E={MOUSE_MOVE_ANNOTATABLE_ITEM:"onMouseMoveOverItem",ANNOTATION_REMOVED:"onAnnotationRemoved",ANNOTATION_CREATED:"onAnnotationCreated",ANNOTATION_UPDATED:"onAnnotationUpdated"},L={DISABLED:"disabled",NO_TEXT:"noText",FULL:"full"},I={ID:"id",TEXT:"text",TIMESTAMP:"timestamp",PROGRESSIVE:"progressive"};let A=!1,w=!1;function R(t){return{x:t.x,y:t.y}}function t(t){var e=t.changedTouches[0],o=(w=!0,new MouseEvent({touchstart:"mousedown",touchmove:"mousemove",touchend:"mouseup"}[t.type],{bubbles:!0,cancelable:!0,view:window,detail:1,screenX:e.screenX,screenY:e.screenY,clientX:e.clientX,clientY:e.clientY,ctrlKey:!1,altKey:!1,shiftKey:!1,metaKey:!1,button:0,relatedTarget:null}));e.target.dispatchEvent(o),A&&(t.preventDefault(),(t=document.elementFromPoint(e.clientX,e.clientY))instanceof HTMLCanvasElement)&&t.dispatchEvent(o)}function r(t,d,i){const a=T('<canvas class="dda-canvas"></canvas>'),r=(t.append(a),new N(this,t,d)),s=new M(t,d);let l=[],c=0,h=void 0,o=void 0,n=void 0;const p=a[0].getContext("2d");let u=d.metadata.position.split("-");2!==u.length&&(u=["bottom","right"]);const f=this,g=(a.droppable({drop:function(t,e){o.geometry.update(m(e.offset.left,e.offset.top)),f.addAnnotation(o),o=void 0},over:function(t,e){e.helper.is(":hidden")||e.helper.hide(),o=new S(e.draggable.attr("annotation-id"),e.draggable[0],e.draggable.attr("annotation-text"),new O(m(e.offset.left,e.offset.top),e.draggable.attr("annotation-width")||e.draggable[0].naturalWidth,e.draggable.attr("annotation-height")||e.draggable[0].naturalHeight,e.draggable.attr("annotation-rotation")),e.draggable.attr("annotation-editable"),c+1)},out:function(t,e){e.helper.is(":hidden")&&e.helper.show(),o=void 0,f.redrawAnnotations()}}),a.mousemove(t=>{var t=g(t.offsetX,t.offsetY);i(E.MOUSE_MOVE_ANNOTATABLE_ITEM,R(t)),o?(f.redrawAnnotations(),o.geometry.update(t),b(o)):h?h(t):0===(t=x(t)).length?(n=void 0,a.css("cursor","default"),r.hide(),f.redrawAnnotations()):!r.isHidden()&&n===t[0]||(n!==t[0]&&(n=t[0],s.show&&s.show(d.hint.iconMove,d.hint.messageMove),a.css("cursor","move"),f.redrawAnnotations(n)),r.show(n,v()))}),a.mouseup(()=>{var t;h&&(t=h(),i(E.ANNOTATION_UPDATED,[t.new.print(),t.old_print]),h=void 0),A=!1}),a.mousedown(t=>{if(w&&!A&&(A=!0,t.type="mousemove",a.trigger(t)),n&&!h){w||r.hide(!0);const o=n.print();let e=g(t.offsetX,t.offsetY);e={x:e.x-n.geometry.center.x,y:e.y-n.geometry.center.y},h=function(t){return t&&(t={x:t.x-e.x,y:t.y-e.y},w&&t.x!==n.geometry.center.x&&t.y!==n.geometry.center.y&&r.hide(),n.geometry.update({x:t.x,y:t.y}),f.redrawAnnotations(n)),{new:n,old_print:o}}}}),function(t,e){return{x:parseInt(t/a.width()*a[0].width),y:parseInt(e/a.height()*a[0].height)}}),e=function(t,e){return{x:parseInt(t*a.width()/a[0].width),y:parseInt(e*a.height()/a[0].height)}},m=function(t,e){return g(t-a.offset().left,e-a.offset().top)},v=function(){var t;if(n)return t=n.geometry.getLowerVertex(),e(t.x,t.y)},b=function(t,o=!1){var n=+t.geometry.width,i=+t.geometry.height,a=-n/2,r=-i/2;if(p.save(),p.beginPath(),p.translate(t.geometry.center.x,t.geometry.center.y),p.rotate(-t.geometry.rotation*Math.PI/180),t.image&&p.drawImage(t.image,a,r,n,i),!t.image||d.annotationStyle.imageBorder){let t,e;t=o?(e=d.annotationStyle.hiBorderColor,d.annotationStyle.hiBorderSize):(e=d.annotationStyle.borderColor,d.annotationStyle.borderSize),p.lineJoin="round",p.lineWidth=1,p.strokeStyle="#000000",p.strokeRect(.5+a,.5+r,n-1,i-1),p.lineJoin="miter",p.lineWidth=t,p.strokeStyle=e,p.strokeRect(1+a+t/2,1+r+t/2,n-2-t,i-2-t)}d.metadata.enabled&&y(t,a,r,n,i),p.restore()},y=function(t,n,i,a,r){var s=d.metadata;if(s.enabled){let o;if("function"==typeof s.value)o=s.value(t);else switch(s.value){case I.ID:o=t.id?.toString();break;case I.TEXT:o=t.text;break;case I.TIMESTAMP:o=new Date(t.created_at)?.toLocaleString();break;default:I.PROGRESSIVE;o=t.progressive}if(""!==o&&void 0!==o){let t;switch(u[0]){case"top":t=i;break;case"middle":t=i+r/2;break;default:t=i+r}let e;switch(u[1]){case"left":e=n;break;case"center":e=n+a/2;break;default:e=n+a}t+=parseInt(s.offsetY)??0,e+=parseInt(s.offsetX)??0,p.font=s.fontSize+" "+s.fontFamily,p.fillStyle=s.color,p.textAlign="center",p.fillText(o,e,t)}}},x=function(e){let o=[];return l.forEach(t=>{t.geometry.intersect(e.x,e.y)&&o.push(t)}),o=o.reverse()};this.resize=function(t,e){a[0].width=t,a[0].height=e},this.clear=function(){p.clearRect(0,0,a[0].width,a[0].height)},this.redrawAnnotations=function(o=void 0){f.clear();let n=void 0;l.forEach(t=>{var e=!!o&&(o instanceof Object?t===o:t.id===o);e&&d.annotationStyle.foreground?(n&&b(n,!0),n=t):b(t,e)}),n&&b(n,!0)},this.getAnnotations=function(){return l},this.addAnnotation=function(o,t=void 0,n=!0){if(c++,o.progressive=c,t)-1<(t=l.indexOf(t))&&(l[t]=o,f.redrawAnnotations());else{let e=!0;for(let t=0;t<l.length;t++)if(l[t].geometry.area<o.geometry.area){l.splice(t,0,o),e=!1;break}e&&l.push(o),b(o),n&&i(E.ANNOTATION_CREATED,[o.print()])}},this.startRotateAnnotation=function(o){if(o.editable!==L.DISABLED){r.hide(!0),s.show&&s.show(d.hint.iconRotate,d.hint.messageRotate),a.css("cursor","default");const n=o.print();let e;h=function(t){return t&&(t=180*Math.atan2(t.y-o.geometry.center.y,t.x-o.geometry.center.x)/Math.PI,o.geometry.update(void 0,o.geometry.rotation+(e-t)),e=t,f.redrawAnnotations(o)),{new:o,old_print:n}}}},this.removeAnnotation=function(t,e=!0){t.editable!==L.DISABLED&&(r.hide(!0),l.splice(l.indexOf(t),1),e&&i(E.ANNOTATION_REMOVED,[t.print()]),f.redrawAnnotations())},this.removeAll=function(e=void 0){e?(l=l.filter(t=>t.id!==e),f.redrawAnnotations()):(l=[],f.clear())},this.editTextAnnotation=function(t,e,o=!0){var n;t.editable===L.FULL&&(n=t.print(),t.text=e,o)&&i(E.ANNOTATION_UPDATED,[t.print(),n])}}function s(t,e){function n(t,e,o){o=o?a(o):void 0,i.addAnnotation(new S(t.id,e,t.text,new O(t.position.center,t.width||e.naturalWidth,t.height||e.naturalHeight,t.rotation),t.editable),o,!1)}this.image=t instanceof T?t:T(t),!this.image[0]instanceof Image&&T.error("Annotable it must be an image."),this.image.wrap(T('<div class="dda-annotationlayer"></div>'));const o=this,i=new r(this.image.parent(),e,function(t,e){o.image.trigger(t,e)}),a=(this.image[0].complete?i.resize(this.image[0].naturalWidth,this.image[0].naturalHeight):this.image[0].onload=function(){i.resize(this.naturalWidth,this.naturalHeight)},function(e){var t=i.getAnnotations().find(t=>t.isEqualPrint(e));return t||T.error("Annotation not found."),t});this.addAnnotation=function(t,e=void 0){var o;t.position&&t.position.center&&t.position.center.x&&t.position.center.y||T.error("Invalid annotation."),t.image?t.image instanceof Image?n(t,t.image,e):((!t.image instanceof String||!t.image.includes("http"))&&T.error("Image must be a URL or an instance of Image."),(o=new Image).src=t.image,o.onload=function(){n(t,this,e)}):n(t,{},e)},this.getAnnotations=function(){const e=[];return i.getAnnotations().forEach(t=>{e.push(t.print())}),e},this.removeAnnotation=function(t){i.removeAnnotation(a(t),!1)},this.removeAll=function(t=void 0){i.removeAll(t)},this.hideAnnotations=function(){i.clear()},this.showAnnotations=function(){i.redrawAnnotations()},this.highlightAnnotation=function(t){i.redrawAnnotations(t instanceof Object?a(t):t)},this.on=function(t,e){this.image.on(t,e)}}document.addEventListener("touchstart",t,{passive:!1}),document.addEventListener("touchmove",t,{passive:!1}),document.addEventListener("touchend",t,{passive:!1}),document.addEventListener("touchcancel",t,{passive:!1});const O=function(t,e=50,o=50,n=0){this.center=t,this.width=e,this.height=o,this.rotation=n,this.area=e*o;let r=void 0;function i(){var t=s.rotation*Math.PI/180,e=Math.sin(t),t=Math.cos(t),o=s.width/2,n=s.height/2,i=o*t,a=n*e,o=o*e,e=n*t;(r={}).topR={x:s.center.x+i-a,y:s.center.y-o-e},r.topL={x:s.center.x-i-a,y:s.center.y+o-e},r.botL={x:s.center.x-i+a,y:s.center.y+o+e},r.botR={x:s.center.x+i+a,y:s.center.y-o+e}}const s=this;this.intersect=function(t,e){r||i();var o=Math.abs(t*r.topL.y-r.topL.x*e+(r.botR.x*e-t*r.botR.y)+(r.topL.x*r.botR.y-r.botR.x*r.topL.y))/2;return(o+=Math.abs(t*r.botR.y-r.botR.x*e+(r.botL.x*e-t*r.botL.y)+(r.botR.x*r.botL.y-r.botL.x*r.botR.y))/2)+Math.abs(t*r.botL.y-r.botL.x*e+(r.topR.x*e-t*r.topR.y)+(r.botL.x*r.topR.y-r.topR.x*r.botL.y))/2+Math.abs(t*r.topR.y-r.topR.x*e+(r.topL.x*e-t*r.topL.y)+(r.topR.x*r.topL.y-r.topL.x*r.topR.y))/2<=s.area},this.getLowerVertex=function(){return r||i(),r.lowerVertex||(r.lowerVertex={x:r.botL.x,y:r.botL.y},Object.keys(r).forEach(t=>{r.lowerVertex.y<r[t].y&&(r.lowerVertex={x:r[t].x,y:r[t].y})})),r.lowerVertex},this.update=function(t,e=void 0){if(t&&(s.center=t),e){for(;360<e;)e-=360;s.rotation=e}r=void 0},this.print=function(){return r||i(),{position:{center:R(s.center),topL:R(r.topL),topR:R(r.topR),botL:R(r.botL),botR:R(r.botR)},rotation:s.rotation,width:e,height:o}}},S=function(t,e,o,n,i=L.NO_TEXT,a=void 0){this.id=t,this.text=o,e instanceof Image&&(this.image=e),this.geometry=n,this.editable=i,this.progressive=a,this.created_at=Date.now();const r=this;this.print=function(){return{id:r.id,progressive:r.progressive,image:r.image?r.image.src:void 0,text:r.text,...r.geometry.print(),editable:r.editable,created_at:r.created_at}},this.isEqualPrint=function(t){return!(!t instanceof Object)&&t.created_at===r.created_at}},M=function(t,e){if(e.hint.enabled){const i=T('<div class="dda-hint-msg dda-opacity-fade" style="opacity: 0;">'+e.hint.message+"</div>"),a=T('<div class="dda-hint-icon">'+e.hint.icon+"</div>");var n=T('<div class="dda-hint"></div>');n.append(i),n.append(a),t.append(n);let o=void 0;const r=this;a.mouseover(()=>{r.show()}),a.mouseout(()=>{r.hide()}),T(e.draggable).mouseover(()=>{r.show()}),this.show=function(t,e){clearTimeout(o),t&&a.html(t),e&&i.html(e),i.css("opacity",1),o=setTimeout(()=>{r.hide()},3e3)},this.hide=function(){clearTimeout(o),i.css("opacity",0),i.html(e.hint.message),a.html(e.hint.icon)}}},N=function(t,e,o){const n=T('<div class="dda-popup-buttons"></div>');var i=T('<button role="button" class="dda-popup-button-rotate" data-toggle="tooltip" title="'+o.popup.tooltipRotate+'">'+o.popup.buttonRotate+"</button>"),a=T('<button role="button" class="dda-popup-button-remove" data-toggle="tooltip" title="'+o.popup.tooltipRemove+'">'+o.popup.buttonRemove+"</button>");n.append(i),n.append(a);const r=T('<div class="dda-popup"></div>').hide(),s=T('<textarea class="dda-popup-textarea" data-toggle="tooltip" title="'+o.popup.tooltipTextarea+'" placeholder = "'+o.popup.placeholderTextarea+'"></textarea>'),d=T('<div class="dda-popup-text" data-toggle="tooltip" title="'+o.popup.tooltipText+'"></div>');r.append(T("<div></div>").append(s)),r.append(d),r.append(n),e.append(r);let l=!1,c=void 0;const h=this;r.mouseover(()=>l=!0),r.mouseout(()=>l=!1),i.click(()=>{t.startRotateAnnotation(c)}),a.click(()=>{t.removeAnnotation(c)}),s.keyup(()=>{t.editTextAnnotation(c,s.val())}),this.show=function(t,e){(c=t).text?d.show().html(c.text):d.hide(),c.editable===L.FULL?(d.hide(),s.show().prop("disabled",!1).removeAttr("style").val(c.text)):s.hide().prop("disabled",!0),c.editable!==L.DISABLED?n.show():n.hide(),r.css({top:e.y,left:e.x}).show()},this.hide=function(t=!1){if(!h.isHidden()&&(w||!l||t)){const e=setTimeout(()=>{!w&&l&&!t||(c=void 0,r.hide()),clearTimeout(e)},300)}},this.isHidden=function(){return r.is(":hidden")}};T.fn.annotable=function(o){let n={},i=void 0;"object"!=typeof o&&o||(n=T.extend(!0,{},T.fn.annotable.defaults,o),i=1<this.length?[]:void 0,T(n.draggable).is(":ui-draggable"))||T(n.draggable).draggable({helper:"clone",ghosting:!0,cursorAt:{top:0,left:0},revert:"invalid",start:function(){A=!0},stop:function(){A=!1}});const a=Array.prototype.slice.call(arguments,1);return this.each(function(){let t=T(this),e=t.data("annotable");if(e){if("string"==typeof o&&e[o])return e[o].apply(e,a);T.error("Method "+o+" does not exist on Annotable")}else n?(e=new s(this,n),t.data("annotable",e),i?i.push(e):i=e):T.error("Annotable is not initialized.")}),i},T.fn.annotable.defaults={draggable:".draggable-annotation",hint:{enabled:!0,message:"Drag and Drop to Annotate",icon:'<i class="fa-regular fa-circle-question"></i>',messageMove:"Drag to set new annotation position",iconMove:'<i class="fa-solid fa-info"></i>',messageRotate:"Move to set new annotation rotation",iconRotate:'<i class="fa-solid fa-info"></i>'},popup:{buttonRotate:'<i class="fa-solid fa-rotate"></i>',tooltipRotate:"Change the rotation of annotation",buttonRemove:'<i class="fa-solid fa-trash"></i>',tooltipRemove:"Remove the annotation",tooltipText:"Text of annotation",tooltipTextarea:"Text of annotation",placeholderTextarea:"Enter Text"},annotationStyle:{borderColor:"#ffffff",borderSize:2,hiBorderColor:"#fff000",hiBorderSize:2.2,imageBorder:!0,foreground:!0},metadata:{enabled:!1,value:I.PROGRESSIVE,fontSize:"40px",fontFamily:"sans-serif",color:"#ff0000",position:"bottom-right",offsetX:-20,offsetY:-10}}}})();
